// timetest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <windows.h>

int verbose = 0;

void figure_resolution(DWORD *total, DWORD *count)
{
	DWORD now, then;
	*total = *count = 0;
	then = timeGetTime();
	while ( (*total) < 1000 )
	{
		now = timeGetTime();
		if (now != then)
		{
			if (verbose)
			    printf("delta %d\n", now - then);
			(*total) += (now - then);
			(*count)++;
		}
		then = now;
	}
}

void test_event(void)
{
	HANDLE myevent;
	DWORD now, then;
	UINT timerid;

	myevent = CreateEvent(NULL, FALSE, FALSE, NULL);
	now = GetTickCount();
	timerid = timeSetEvent(50, 500, (LPTIMECALLBACK) myevent, 
		0,
		TIME_PERIODIC | TIME_CALLBACK_EVENT_SET);
	
	WaitForSingleObject(myevent, INFINITE);
	then = GetTickCount();
	printf("event took %ld ms\n", then - now);
	now = then;

	WaitForSingleObject(myevent, INFINITE);
	then = GetTickCount();
	printf("event took %ld ms\n", then - now);
	now = then;

    WaitForSingleObject(myevent, INFINITE);
	then = GetTickCount();
	printf("event took %ld ms\n", then - now);
	now = then;


	timeKillEvent(timerid);
}

int dragheels = 0;
int e2count = 0;
void CALLBACK event2_callback(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	e2count++;
    printf("event2_callback: start at %lu(delta %lu): [id %u|msg %u|dwUser %lu|dw1 %lu|dw2 %lu]\n", 
                GetTickCount(), GetTickCount() - (DWORD) dwUser, uTimerID, uMsg, dwUser, dw1, dw2);
    if (dragheels)
        Sleep(dragheels);
    printf("event2_callback: end at %lu(delta %lu)\n", 
                GetTickCount(), GetTickCount() - (DWORD) dwUser);
}

void test_event2(UINT resolution, int drag, int delay, int spinflag)
{
	UINT timerid;
	DWORD start, now;

        printf("event2 test:  [resolution %d|drag %d|delay %d|spin %d]\n", resolution, drag, delay, spinflag);
        dragheels = drag;
		e2count = 0;
	timerid = timeSetEvent(drag / 2, resolution, event2_callback, 
		GetTickCount(),
		TIME_PERIODIC);

        if (spinflag)
            for (start = now = GetTickCount(); now <= start + delay; now = GetTickCount())
                ;
        else
            Sleep(delay);

        dragheels = 0;

        if (spinflag)
            for (start = now = GetTickCount(); now <= start + delay; now = GetTickCount())
                ;
        else
            Sleep(delay);


	timeKillEvent(timerid);
	printf("event2 done %d times:  [resolution %d|drag %d|delay %d|spin %d]\n", e2count, resolution, drag, delay, spinflag);
}

int main(int argc, char* argv[])
{
	TIMECAPS tc;
	DWORD total, count;
	MMRESULT rc;

	if (argc > 1 && strcmp(argv[1], "-v") == 0)
		verbose++;

	timeGetDevCaps(&tc, sizeof(tc));

	printf("timeGetDevCaps [min %u/max %u]\n", 
			tc.wPeriodMin, tc.wPeriodMax);

	figure_resolution(&total, &count);

	printf("resolution total amount %lu, count %lu, average %lu\n",
		total, count, total / count);

	test_event();

    test_event2(1, 100, 500, 0);
    test_event2(1000, 100, 500, 0);
    test_event2(1, 100, 500, 1);

	rc = timeBeginPeriod(500);
	printf("rc is %d(%s)\n", rc, rc == TIMERR_NOERROR ? "NOERROR" :
	    rc == TIMERR_NOCANDO ? "NOCANDO" : "Unknown");

	figure_resolution(&total, &count);

	printf("[500] resolution total amount %lu, count %lu, average %lu\n",
		total, count, total / count);

	test_event();


	return 0;
}

/* TODO:  See what happens if an event takes a long time */
/*        See what the wResol flag does                  */
/*        See how accurate Windows is under heavy load   */
